<?php

ini_set('display_errors', 1);

// Set errors
$intErrors = 0;
$strErrorMsg = "";

require_once('TwitterAPIExchange.php');
require_once('GetSharedParams.php');

// Get specific parameters:

if(isset($_GET['booGetAll']) && !empty($_GET['booGetAll'])){
	$booGetAll = $_GET["booGetAll"];
} else {
    $intErrors = $intErrors + 1;
	$strErrorMsg = $strErrorMsg . "booGetAll missing, ";
}

if(isset($_GET['strIDType']) && !empty($_GET['strIDType'])){
	$strIDType = $_GET["strIDType"];

	switch ($strIDType) {
		 case "followers":
			$url = 'https://api.twitter.com/1.1/followers/ids.json';
			break;
		 case "friends":
			$url = 'https://api.twitter.com/1.1/friends/ids.json';
			break;
		 case "blocks":
			$url = 'https://api.twitter.com/1.1/blocks/ids.json';
			break;
		case "pending":
			$url = 'https://api.twitter.com/1.1/friendships/outgoing.json';
			break;	
		 default:
		 
		$intErrors = $intErrors + 1;
		$strErrorMsg = $strErrorMsg . "strIDType not recognised, ";
	 } 	
	
} else {
    $intErrors = $intErrors + 1;
	$strErrorMsg = $strErrorMsg . "strIDType missing, ";
}

// strScreenName is irrelevant for blocks or pending checking. It only reports details for the authenticated user.  Leaving it in doesn't cause any problems, it is just ignored:
if(isset($_GET['strScreenName']) && !empty($_GET['strScreenName'])){
	$strScreenName = $_GET["strScreenName"];
} else {
    $intErrors = $intErrors + 1;
	$strErrorMsg = $strErrorMsg . "strScreenName missing, ";
}

// for use when cursoring is required:
if(isset($_GET['strNextCursor']) && !empty($_GET['strNextCursor'])){
	$strNextCursor = $_GET["strNextCursor"];
} else {
    $intErrors = $intErrors + 1;
	$strErrorMsg = $strErrorMsg . "strNextCursor missing, ";
}

// Maximum count is 5000
if(isset($_GET['intAPIMaxCount']) && !empty($_GET['intAPIMaxCount'])){
	$intAPIMaxCount = $_GET["intAPIMaxCount"];
} else {
    $intErrors = $intErrors + 1;
	$strErrorMsg = $strErrorMsg . "intAPIMaxCount missing";
}

if ($intErrors > 0 ) {
	echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" . "\r\n";
	echo "	<ids>" . "\r\n";
	echo "		<id>" . "\r\n";
	echo "			<next_cursor_str>-1</next_cursor_str>" . "\r\n";
	echo "			<code>params</code>" . "\r\n";
	echo "			<message>" . $intErrors  . " parameter error(s) - " . $strErrorMsg . "</message>" . "\r\n";
	echo "		</id>" . "\r\n";
	echo "	</ids>";
	die;
}

/** Set access tokens here - see: https://dev.twitter.com/apps/ **/
$settings = array(
    'oauth_access_token' => $oat,
    'oauth_access_token_secret' => $oats,
    'consumer_key' => $ck,
    'consumer_secret' => $cs
);

	echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" . "\r\n";
	echo "	<ids>" . "\r\n";

while ($strNextCursor != "0"){
	$getfield = '?screen_name=' . $strScreenName . '&count='. $intAPIMaxCount .'&cursor=' . $strNextCursor;
	$requestMethod = 'GET';
	$twitter = new TwitterAPIExchange($settings);
	
	$followers=$twitter->setGetfield($getfield)
				 ->buildOauth($url, $requestMethod)
				 ->performRequest();
	
	$arrayContent = json_decode($followers, true);
		
	if (array_key_exists('errors', $arrayContent)) {

		echo "		<id>" . "\r\n";		
		echo "			<next_cursor_str>" . $strNextCursor . "</next_cursor_str>" . "\r\n";
		echo "			<code>" . $arrayContent['errors'][0]['code'] . "</code>" . "\r\n";
		echo "			<message>" . $arrayContent['errors'][0]['message'] . "</message>" . "\r\n";
		echo "		</id>" . "\r\n";
		echo "	</ids>" . "\r\n";
		die;
	}
	
	$arrayCount = count($arrayContent['ids']);
	$arrayCurPos = 0;
	
	while ($arrayCurPos < $arrayCount){
		echo "		<id>" . "\r\n";		
		echo "			<tid>" . $arrayContent['ids'][$arrayCurPos]."</tid>" . "\r\n";
		echo "		</id>" . "\r\n";
		$arrayCurPos = $arrayCurPos + 1;
	}
	
	// If the variable $booGetAll is True, then continue as per normal,
	// else automatically set the $strNextCursor value to "0" to stop 
	// any additional grabs.  This effectively forces the script to only 
	// grab the number of IDs specified in the $intAPIMaxCount variable.
	
	if ($booGetAll == "True" OR $booGetAll == "true" OR $booGetAll == "TRUE") {
		$strNextCursor = $arrayContent['next_cursor_str'];
	}
	else {
		$strNextCursor = "0";
	}
}

echo "		<id>" . "\r\n";
echo "			<next_cursor_str>" . $strNextCursor . "</next_cursor_str>" . "\r\n";
echo "			<code>0</code>" . "\r\n";
echo "		</id>" . "\r\n";
echo "	</ids>" . "\r\n";

?>